/////////////////////////////////////////////////////////////////////////////
//	Author 	: Venkadesh M
//	Date	: 20/06/203
//	Purpose	: Keypad interfacing
////////////////////////////////////////////////////////////////////////////

#include <pic.h>
#include <htc.h>
#define _XTAL_FREQ 20000000
#include "keypad.h"
#include "GPIO.h"

char keypress = 0;
char newkey = NUNE;
char numkey = 0;


/////////////////////////////////////////////////////////////////////////////
//	Author 	: Venkadesh M
//	Date	: 20/06/203
//	Purpose	: Keypad initializing
////////////////////////////////////////////////////////////////////////////
void keypad_init(void)
{
	TRISB = 0x0F;
	PORTB = 0x0F;
	newkey = NUNE;
}

/////////////////////////////////////////////////////////////////////////////
//	Author 	: Venkadesh M
//	Date	: 20/06/203
//	Purpose	: Keypad monitoring
////////////////////////////////////////////////////////////////////////////
void keypad_monitor(void)
{
	static char p;
	char oldkey;
	
	if(keycheck())
	{
		keypress = 0;
		newkey = NUNE;
		return;
	}

	buzz = 1;

	__delay_ms(30);   //debounce logic
	__delay_ms(15);


	if(keycheck())
	{
		keypress = 0;
		newkey = NUNE;
		buzz = 0;
		return;
	}

	oldkey = newkey;
	newkey = find_key();
	
	if(newkey == oldkey || newkey == NUNE)
	{
		keypress = 0;
		numkey = 0;
		p++;
	}
	else
	{
		keypress = 1;
		p=0;
		if( (newkey <= 10) && (newkey != 8))
		numkey = 1;
	}
	
	buzz = 0;
}

/////////////////////////////////////////////////////////////////////////////
//	Author 	: Venkadesh M
//	Date	: 20/06/203
//	Purpose	: check for key press
////////////////////////////////////////////////////////////////////////////
char keycheck(void)
{
	scn_in(0);
	
	if(scn_out == 0xF)
	return 1;
	
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
//	Author 	: Venkadesh M
//	Date	: 20/06/203
//	Purpose	: check for key press
////////////////////////////////////////////////////////////////////////////
char find_key()
{
	char i;
	if(scn_out == 0xF)
	return NUNE;
	
	for(i=0;i<4;i++)
	{
	scn_in(0b11110111>>i);
		switch(scn_out)
		{
			case 0b1110: return i;
			case 0b1101: return i+4;
			case 0b1011: return i+8;
			case 0b0111: return i+12;
		}
	}
	return NUNE;
}



